require_once

require_once() 语句在脚本执行期间包含并运行指定文件。此行为和 require() 语句类似,唯一区别是如果该文件中的代码已经被包含了,则不会再次包含。有关此语句怎样工作参见 require() 的文档。

require_once() 应该用于在脚本执行期间同一个文件有可能被包含超过一次的情况下,想确保它只被包含一次以避免函数重定义,变量重新赋值等问题。

使用 require_once()include_once() 的例子见最新的 PHP 源程序发行包中的 » PEAR 代码。

返回值和 include() 相同。如果文件已被包含,本函数返回 TRUE

注意:

require_once() 是 PHP 4.0.1pl2 中新加入的。

注意:

要注意 require_once()include_once() 在大小写不敏感的操作系统中(例如 Windows)的行为可能不是所期望的。

例 7.12. require_once() 在 Windows 下不区分大小写

<?php
require_once("a.php"); // this will include a.php
require_once("A.php"); // this will include a.php again on Windows!
?>

此行为在 PHP 5 中改了,路径先被规格化,因此 C:\PROGRA~1\A.phpC:\Program Files\a.php 的实现一样,文件只会被包含一次。

警告:

Windows 版本的 PHP 在 4.3.0 版之前不支持本函数的远程文件访问,即使 allow_url_fopen 选项已被激活。

参见 require()include()include_once()get_required_files()get_included_files()readfile()virtual()